var storeArray = [];
var screenwidth;
var scr_iconWidth = 25;
var scr_iconHeight = 15;
var scr_iconZoom = 1;
var iconArray = [
  ['buttonDiv1', 'Driving', 'driving', 'driving'],
  ['buttonDiv2', 'Walking', 'walking', 'walking'],
  ['buttonDiv3', 'Bicycling', 'bicycling', 'bicycling']
];

function doOnOrientationChange() {
  switch (window.orientation) {
    case -90:
    case 90:
      //landscape;
      screenwidth = $(window).width();
      break;
    default:
      //portrait;
      screenwidth = $(window).height();
      break;
  }

  if (screenwidth >= 928) {
    scr_iconZoom = 1.5;
  }
}

doOnOrientationChange();

var xml;
var props;
var firstMap = false;
var firstExpand = true;
var firstPostcode = true;
var firstView = true;
var postcode;
var tempArray = [];
var finalArray = [];
var lat;
var lon;
var startLocation;
var transMethod;
var results;
var autoCalculate;
var transRouteMode;
var closeButton;
var startIcon;
var endIcon;
var globalZIndex;

var map;
var infowindow;
var latlng;
var geocoder;
var centerChangedLast;
var reverseGeocodedLast;
var currentReverseGeocodeResponse;
var directionsDisplay;
var directionsService;
var gmarkers = [];
var icons;
var iconShadow;
var latlngStart;
var latlngEnd;

var transMethodText;
var distanceKM;
var distanceMin;

function findStores(properties) {
  screenad.setBlockPageTouches(true);

  props = properties || {};
  props.apiKey = properties.apiKey || 'AIzaSyAgEeg19baoVpioF9Lh5L9KHRiht-Ed_Y0';
  props.startLocation = properties.startLocation || 'true';
  props.transMethod = properties.transMethod || 'walking';
  props.results = properties.results || 3;
  props.autoCalculate = properties.autoCalculate || 'false';
  props.mapWidth = properties.mapWidth || '100%';
  props.mapHeight = properties.mapHeight || '100%';
  props.mapTop = properties.mapTop || '0px';
  props.mapLeft = properties.mapLeft || '0px';
  props.closeButton = properties.closeButton || 'true';
  props.startIcon = properties.startIcon || 'marker_green.png';
  props.endIcon = properties.endIcon || 'marker_red.png';
  props.zIndex = properties.zIndex || 110;

  transMethod = props.transMethod;
  results = props.results;
  autoCalculate = props.autoCalculate;
  closeButton = props.closeButton;
  startIcon = props.startIcon;
  endIcon = props.endIcon;
  globalZIndex = props.zIndex;

  var apiUrl = '//maps.googleapis.com/maps/api/js?key=' + props.apiKey + '&language=nl&region=NL';
  //var apiUrl = '//maps.googleapis.com/maps/api/js?language=nl&region=NL';

  $.getScript(apiUrl)
    .done(function(script, textStatus, jqxhr) {
      // console.log(script, textStatus, jqxhr.status);
      directionsDisplay = new google.maps.DirectionsRenderer();

      google.maps.LatLng.prototype.distanceFrom = function(newLatLng) {
        // setup our variables
        var lat1 = this.lat();
        var radianLat1 = lat1 * (Math.PI / 180);
        var lng1 = this.lng();
        var radianLng1 = lng1 * (Math.PI / 180);
        var lat2 = newLatLng.lat();
        var radianLat2 = lat2 * (Math.PI / 180);
        var lng2 = newLatLng.lng();
        var radianLng2 = lng2 * (Math.PI / 180);
        // sort out the radius, MILES or KM?
        var earth_radius = 637810; // (km = 637810) OR (miles = 39590) - radius of the earth

        // sort our the differences
        var diffLat = (radianLat1 - radianLat2);
        var diffLng = (radianLng1 - radianLng2);
        // put on a wave (hey the earth is round after all)
        var sinLat = Math.sin(diffLat / 2);
        var sinLng = Math.sin(diffLng / 2);

        var a = Math.pow(sinLat, 2.0) + Math.cos(radianLat1) * Math.cos(radianLat2) * Math.pow(sinLng, 2.0);

        // work out the distance
        var distance = earth_radius * 2 * Math.asin(Math.min(1, Math.sqrt(a)));

        // return the distance
        return distance;
      };
      getStores();
    })
    .fail(function(jqxhr, settings, exception) {
      console.log(jqxhr, settings, exception);
    });
}

function getStores() {
  if (window.XMLHttpRequest) {
    xmlhttp = new XMLHttpRequest();
  } else {
    xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
  }
  xmlhttp.open("GET", "stores.xml", true);
  xmlhttp.send();
  xmlhttp.onreadystatechange = function(e) {
    if (this.readyState == 4 && this.status == 200) {
      xmlDoc = xmlhttp.responseXML;
      xml = xmlDoc.getElementsByTagName('store');
      onReady();
    }
  };
}

function onReady() {
  for (i = 0; i < xml.length; i++) {
    storeArray[i] = [
      xml[i].getElementsByTagName('name')[0].childNodes[0].nodeValue,
      xml[i].getElementsByTagName('address')[0].childNodes[0].nodeValue,
      xml[i].getElementsByTagName('postalcode')[0].childNodes[0].nodeValue,
      xml[i].getElementsByTagName('location')[0].childNodes[0].nodeValue,
      xml[i].getElementsByTagName('phone')[0].childNodes[0].nodeValue,
      xml[i].getElementsByTagName('website')[0].childNodes[0].nodeValue,
      xml[i].getElementsByTagName('lat')[0].childNodes[0].nodeValue,
      xml[i].getElementsByTagName('lng')[0].childNodes[0].nodeValue
    ];
  }

  if (firstMap === false) {
    firstMap = true;

    $('<div id="mapWrapper"></div>')
      .appendTo('body')
      .css({
        'position': 'absolute',
        'top': props.mapTop,
        'left': props.mapLeft,
        'width': props.mapWidth,
        'height': props.mapHeight,
        'z-index': props.zIndex
      });

    $('<div id="mapDiv"></div>')
      .appendTo('#mapWrapper')
      .css({
        'position': 'absolute',
        'top': '0px',
        'left': '0px',
        'width': '100%',
        'height': '100%',
        'z-index': props.zIndex + 1,
        'background': '#DDDDDD'
      });

    $('<div id="overlay"></div>')
      .appendTo('#mapWrapper')
      .css({
        'position': 'absolute',
        'top': '0px',
        'left': '0px',
        'width': '100%',
        'height': '100%',
        'z-index': props.zIndex + 2,
        'color': '#FFFFFF',
        'opacity': '0.75',
        'text-align': 'center',
        'background': 'rgba(0, 0, 0, 0.75)'
      });

    $('<div id="loading"></div>')
      .appendTo('#overlay')
      .css({
        'position': 'absolute',
        'top': ($('#mapWrapper').height() / 2) - ($(this).height() / 2) + 'px',
        'left': ($('#mapWrapper').width() / 2) - ($(this).width() / 2) + 'px',
        'width': '100%',
        'height': '100%',
        'z-index': props.zIndex + 3,
        'opacity': '1',
        'background': 'url(\'loading.gif\') fixed center no-repeat'
      });

    $('<div id="text"></div>')
      .appendTo('overlay')
      .css({
        'position': 'absolute',
        'top': ($('#mapWrapper').height() / 2) - ($(this).height() / 2) + 'px',
        'left': ($('#mapWrapper').width() / 2) - ($(this).width() / 2) + 'px',
        'width': '114px',
        'height': '21px',
        'z-index': props.zIndex + 4,
        'color': '#FFFFFF',
        'text-align': 'center'
      })
      .html('Directions updated');

    if (closeButton == 'true') {
      $('<img id="close_button" />')
        .appendTo('#mapWrapper')
        .css({
          'position': 'absolute',
          'top': '0px',
          'left': ($('#mapWrapper').width() - 40) + 'px',
          'width': '44px',
          'height': '44px',
          'z-index': props.zIndex + 5
        })
        .attr('src', '//media.adrcdn.com/ad-resources/weborama_close_88x88.png')
        .click(function() {
          closeStores();
        });
    }
  }

  $('#mapWrapper').show();
  $('#overlay').show();
  $('#loading').show();
  $('#mapDiv').show();
  $('#text').hide();

  if (props.startLocation == 'true') {
    navigator.geolocation.getCurrentPosition(
      onSuccess,
      onError, {
        maximumAge: 30000,
        timeout: 3000
      }
    );
  } else {
    startLocation = false;

    if (!firstPostcode) {
      $('#overlay').hide();
    }

    $('#loading').hide();
    $('#map').hide();

    createPostcodeField();
  }
}

function onSuccess(position) {
  screenad.event('user_geo');
  startLocation = true;
  lat = position.coords.latitude;
  lon = position.coords.longitude;
  initialize(lat, lon);
}

function onError(e) {
  startLocation = false;

  if (!firstPostcode) {
    $('#overlay').hide();
  }

  $('#loading').hide();
  $('#map').hide();

  screenad.event('no_geo_data');

  switch (e.code) {
    case 1:
      console.log('The user said no!');
      break;
    case 2:
      console.log('Location data unavailable');
      break;
    case 3:
      console.log('Location request timed out');
      break;
    default:
      console.log('Unknown error');
      break;
  }

  createPostcodeField();
}

function TransDistance(controlDiv, map) {
  $(controlDiv).css({
    'padding': '5px 5px 0px 5px',
  });

  $('<div id="textDistance"></div>')
    .appendTo(controlDiv)
    .css({
      'background': '#F5F5F5',
      'border': '1px solid #A7A7A7',
      'border-radius': '3px',
      '-moz-border-radius': '3px',
      '-webkit-border-rradius': '3px',
      'cursor': 'default',
      'font-family': 'Verdana, Geneva ,sans-serif',
      'font-size': '11pt',
      'height': '20px',
      'margin-bottom': '5px',
      'padding': '4px',
      'text-align': 'left'
    });
}

function TransMethodControl(controlDiv, map) {
  $(controlDiv).css({
    'padding': '5px',
  });

  for (var i = 0; i < iconArray.length; i++) {
    $('<div id="' + iconArray[i][0] + '"></div>')
      .appendTo(controlDiv)
      .css({
        'background': 'url(\'' + iconArray[i][2] + '.png\')',
        'background-size': (scr_iconWidth * scr_iconZoom) + 'px ' + (scr_iconHeight * scr_iconZoom) + 'px',
        'cursor': 'default',
        'height': (scr_iconHeight * scr_iconZoom) + 'px',
        'text-align': 'center',
        'width': (scr_iconWidth * scr_iconZoom) + 'px'
      })
      .attr('title', iconArray[i][1])
      .attr('onclick', 'changeTransMethod(\'' + iconArray[i][3] + '\');');
  }
}

function setIcons(target, image, selected) {
  for (var k = 0; k < iconArray.length; k++) {
    $('#' + iconArray[k][0]).css({
      'background-image': 'url(\'' + iconArray[k][2] + '.png\')',
      'background-size': (scr_iconWidth * scr_iconZoom) + 'px ' + (scr_iconHeight * scr_iconZoom) + 'px',
      'cursor': 'pointer'
    });

    if (iconArray[k][0] == target) {
      $('#' + target).css({
        'background-image': 'url(\'' + image + '_selected.png\')',
        'cursor': 'default'
      });
    }
  }
}

function closeStores() {
  screenad.setBlockPageTouches(false);
  gmarkers = [];
  $('#mapWrapper').hide();
}

function createPostcodeField() {
  screenad.event('user_create_postcode');
  if (firstPostcode) {
    firstPostcode = false;

    $('<div id="postcode"></div>')
      .appendTo('#overlay')
      .css({
        'opacity': '1',
        'position': 'absolute',
        'top': '0px',
        'left': '0px',
        'width': '100%',
        'height': '100%',
        'z-index': globalZIndex + 6
      });

    $('<div id="post_form"></div>')
      .appendTo('#postcode')
      .css({
        'opacity': '1',
        'position': 'absolute',
        'width': '200px',
        'height': '58px',
        'top': ($('#postcode').height() / 2) - (58 / 2) + 'px',
        'left': ($('#postcode').width() / 2) - (200 / 2) + 'px',
        'z-index': globalZIndex + 7
      });

    $('<div id="post_text"></div>')
      .appendTo('#post_form')
      .html('<span>Vul hier je postcode in:</span>');

    $('<input id="postcode_val" name="postcode" size="7" maxlength="6" />')
      .appendTo('#post_form')
      .css({
        'background': 'rgba(255, 255, 255, 1)',
        'font-size': '16pt',
        'height': '32px',
        'text-transform': 'uppercase'
      });

    $('<input id="postcode_btn" type="button" value="Zoek" onclick="postcodeChecker();" />')
      .appendTo('#post_form');
  }

  $('#postcode').show();
}

function postcodeChecker() {
  var postcode = $('#postcode_val').val();
  var abc = ['a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z'];
  if (postcode.length >= 4) {
    if (jQuery.type(Number(postcode.slice(0, 4))) === 'number') {
      var correct = 0;
      for (var i = 4; i < 6; i++) {
        for (var j = 0; j < abc.length; j++) {
          if (postcode[i] == abc[j]) {
            correct++;
          }
        }
      }
      if (correct == 2) {
        postcodeHandler();
      }
    } else {
      alert('U heeft geen geldige postcode ingevoerd.');
      return false;
    }
  } else {
    alert('U heeft geen geldige postcode ingevoerd.');
    return false;
  }
}

function postcodeHandler() {
  var postcodes = $('#postcode_val').val();
  var geocoder = new google.maps.Geocoder();

  $('#postcode').hide();
  $('#overlay').hide();
  $('#loading').show();

  var address = postcodes + ', Nederland';

  geocoder.geocode({ 'address': address }, function(results, status) {
    if (status == google.maps.GeocoderStatus.OK) {
      startLocation = true;
      lat = results[0].geometry.location.lat();
      lon = results[0].geometry.location.lng();
      initialize(lat, lon);
    } else {
      alert('Geocode was not successful for the following reason: ' + status);
    }
  });
  $('#mapDiv').show();
  screenad.event('user_postcode');
}

function initialize(latitude, longitude) {
  icons = {
    start: new google.maps.MarkerImage(
      startIcon,
      new google.maps.Size(20, 34),
      new google.maps.Point(0, 0),
      new google.maps.Point(9, 34)
    ),
    end: new google.maps.MarkerImage(
      endIcon,
      new google.maps.Size(20, 34),
      new google.maps.Point(0, 0),
      new google.maps.Point(9, 34)
    )
  };

  iconShadow = new google.maps.MarkerImage(
    'shadow.png',
    new google.maps.Size(20, 34),
    new google.maps.Point(0, 0),
    new google.maps.Point(9, 34)
  );

  var rendererOptions = {
    map: map,
    suppressMarkers: true
  };

  directionsDisplay = new google.maps.DirectionsRenderer(rendererOptions);
  latlng = new google.maps.LatLng(latitude, longitude);
  latlngStart = new google.maps.LatLng(lat, lon);

  var myOptions = {
    zoom: 10,
    center: latlng,
    icon: icons.start,
    panControl: false,
    mapTypeControl: false,
    mapTypeControlOptions: {
      style: google.maps.MapTypeControlStyle.DROPDOWN_MENU
    },
    zoomControl: false,
    zoomControlOptions: {
      style: google.maps.ZoomControlStyle.SMALL
    },
    scaleControl: true,
    streetViewControl: false,
    mapTypeId: google.maps.MapTypeId.ROADMAP
  };
  map = new google.maps.Map(document.getElementById('mapDiv'), myOptions);

  var transDistanceDiv = document.createElement('div');
  var transDistance = new TransDistance(transDistanceDiv, map);

  transDistanceDiv.index = 1;
  map.controls[google.maps.ControlPosition.TOP_LEFT].push(transDistanceDiv);

  var transMethodControlDiv = document.createElement('div');
  var transMethodControl = new TransMethodControl(transMethodControlDiv, map);

  transMethodControlDiv.index = 1;
  map.controls[google.maps.ControlPosition.LEFT_TOP].push(transMethodControlDiv);

  directionsDisplay.setMap(map);

  var numberOfTries = 0;

  function checkIcons() {
    numberOfTries++;
    if (numberOfTries >= 50) return false;
    setTimeout(function() {
      try {
        if (document.getElementById('buttonDiv1')) {
          if (transMethod == 'driving') {
            setIcons('buttonDiv1', iconArray[0][2], true);
          } else if (transMethod == 'walking') {
            setIcons('buttonDiv2', iconArray[1][2], true);
          } else if (transMethod == 'bicycling') {
            setIcons('buttonDiv3', iconArray[2][2], true);
          }
        } else {
          checkIcons();
        }
      } catch (e) { checkIcons(); }
    }, 50);
  }
  checkIcons();

  infowindow = new google.maps.InfoWindow({
    position: new google.maps.LatLng(0, 0),
    pixelOffset: new google.maps.Size(0, 0)
  });

  createMarker(latlng, icons.start, 'I\'m Here!', '');

  if (startLocation === true) {
    $('#overlay').hide();
    $('#loading').hide();
    $('#mapDiv').show();
    $('#text').hide();

    AddData();
  }
}

function AddData() {
  map.setOptions({
    center: new google.maps.LatLng(lat, lon),
    zoom: 13
  });

  var companyName;
  var companyAddress;
  var companyPostcode;
  var companyCity;
  var companyPhone;
  var companySite;
  var companyLat;
  var companyLon;

  for (var j = 0; j < xml.length; j++) {
    companyLat = storeArray[j][6];
    companyLon = storeArray[j][7];

    var latlngStore = new google.maps.LatLng(companyLat, companyLon);
    var meterDistance = latlngStart.distanceFrom(latlngStore).toFixed(1);

    var sumTotal = meterDistance;

    sumTotal = sumTotal.toString();
    sumTotal = sumTotal.replace(/[^\d]/, '');

    tempArray[j] = [j, sumTotal, storeArray[j][0]];
  }

  function compareNumbers(a, b) {
    return a[1] - b[1];
  }

  tempArray.sort(compareNumbers);
  tempArray = tempArray.slice(0, results);

  for (var l = 0; l < tempArray.length; l++) {
    var k = tempArray[l][0];
    companyName = storeArray[k][0];
    companyAddress = storeArray[k][1];
    companyPostcode = storeArray[k][2];
    companyCity = storeArray[k][3];
    companyPhone = storeArray[k][4];
    companySite = storeArray[k][5];
    companyLat = storeArray[k][6];
    companyLon = storeArray[k][7];

    finalArray[l] = [k, companyPostcode, companyLat, companyLon, tempArray[l][1]];

    latlngStart = new google.maps.LatLng(lat, lon);
    latlngEnd = new google.maps.LatLng(companyLat, companyLon);

    var parameterString = '(\'' + latlngStart + '\', \'' + latlngEnd + '\', \'' + transMethod + '\')';

    var websiteLink = 'Website';
    websiteLink = websiteLink.link(companySite);
    websiteLink = websiteLink.fontcolor('');

    var description = '<div style="text-decoration: none;">' + companyAddress + '<br/>' + companyPostcode + ' ' + companyCity + '</div><br/>';
    description += '<div style="text-decoration: underline; cursor: pointer; float: left; height: 16px;" onclick="screenad.makeCall(\'' + companyPhone + '\'); screenad.event(\'user_call_store_' + companyPostcode.replace(' ', '') + '\');">' + companyPhone + '</div>';
    description += '<div style="text-decoration: none; float: left; margin: 0px 5px 0px 5px;"> | </div>';
    description += '<div style="text-decoration: underline; cursor: pointer; float: left; height: 16px; color: #000;"><a href="' + companySite + '" target="_blank" onclick="screenad.event(\'user_click_website\');" style="color: #000;">Website</a></div><br/><br/>';
    description += '<div style="text-decoration: underline; cursor: pointer; float: left; height: 16px;" onclick="javascript:void(0); calculateDirection' + parameterString + '; screenad.event(\'user_select_store_' + companyPostcode.replace(' ', '') + '\');">Bereken route</div><br/><br/>';
    description += '<div style="text-decoration: underline; cursor: pointer; float: left; height: 16px;" onclick="javascript:void(0); mapsApp' + parameterString + '; screenad.event(\'user_select_store_' + companyPostcode.replace(' ', '') + '\');">Bereken route in maps app</div>';

    createMarker(new google.maps.LatLng(companyLat, companyLon), icons.end, companyName, description);
  }

  if (results == 1 || autoCalculate == 'true') {
    setTimeout(function() {
      latlngEnd = new google.maps.LatLng(finalArray[0][2], finalArray[0][3]);
      calculateDirection(latlngStart, latlngEnd, transMethod);
      screenad.event('auto_select_store_' + companyPostcode.replace(' ', ''));
    }, 150);
  }
}

function createMarker(position, icon, title, html) {
  var contentString = '<span style="font-size: 10pt; height: 250px;"><b>' + title + '</b><br>' + html + '</span>';
  var marker = new google.maps.Marker({
    position: position,
    map: map,
    shadow: iconShadow,
    icon: icon,
    title: title
  });

  marker.myname = title;
  gmarkers.push(marker);

  google.maps.event.addListener(marker, 'click', function() {
    map.setOptions({
      center: position,
      zoom: 12,
    });
    infowindow.setOptions({
      content: contentString,
      maxWidth: 250
    });
    infowindow.open(map, marker);
  });
}

function calculateDirection(current, target, transMethod) {
  infowindow.close();

  if (transMethod == 'driving') {
    transMethodText = 'Driving';
    transRouteMode = google.maps.DirectionsTravelMode.DRIVING;
  } else if (transMethod == 'walking') {
    transMethodText = 'Walking';
    transRouteMode = google.maps.DirectionsTravelMode.WALKING;
  } else if (transMethod == 'bicycling') {
    transMethodText = 'Bicycling';
    transRouteMode = google.maps.DirectionsTravelMode.BICYCLING;
  } else if (transMethod == 'transit') {
    transRouteMode = google.maps.DirectionsTravelMode.WALKING;
  }

  var request = {
    origin: current,
    destination: target,
    travelMode: transRouteMode,
    unitSystem: google.maps.DirectionsUnitSystem.METRIC
  };

  new google.maps.DirectionsService().route(request, function(response, status) {
    if (status == google.maps.DirectionsStatus.OK) {
      directionsDisplay.setDirections(response);
      var leg = response.routes[0].legs[0];
      distanceKM = leg.distance.text;
      distanceMin = leg.duration.text;
      setTimeout(function() {
        $('#textDistance').html(transMethodText + 'route = ' + distanceKM + ', ' + distanceMin + '<br>\n');
      }, 1000);
      $('#loading').hide();
    }
  });
}

function changeTransMethod(transMethod) {
  setIcons(event.target.id, transMethod, true);
  if (directionsDisplay.directions !== undefined) {
    var startLat = directionsDisplay.directions.routes[0].legs[0].start_location.lat();
    var startLon = directionsDisplay.directions.routes[0].legs[0].start_location.lng();
    var endLat = directionsDisplay.directions.routes[0].legs[0].end_location.lat();
    var endLon = directionsDisplay.directions.routes[0].legs[0].end_location.lng();
    latlngStart = new google.maps.LatLng(startLat, startLon);
    latlngEnd = new google.maps.LatLng(endLat, endLon);
    calculateDirection(latlngStart, latlngEnd, transMethod);
  }
}

function mapsApp(current, target) {
  var timeOfClick = new Date();
  if (screenad.browser.os.ios && screenad.browser.os.version >= 6) {
    setTimeout(function noGoogleMapsApp() {
      if (new Date() - timeOfClick < 50) {
        top.location.href = 'maps://?z=15&ll=' + current + '&daddr=' + target;
      }
    }, 25);
    top.location.href = 'comgooglemaps://?zoom=15&center=' + current + '&daddr=' + target;
  } else {
    top.location.href = 'https://maps.google.com/?z=15&ll=' + current + '&saddr=' + current + '&daddr=' + target;
  }
}